angular.module('selae.core.controllers')
.controller('HomeCtrl', ['$scope','$state', '$rootScope', 'config', '$ionicScrollDelegate', 'loginSrv', 'popupSrv', '$filter','htmlModalSrv','requestSrv', 'storageProvider', 'analyticsSrv', 'gamesProvider', '$timeout',
	function($scope, $state, $rootScope, config, $ionicScrollDelegate, loginSrv, popupSrv, $filter, htmlModalSrv, requestSrv, storageProvider, analyticsSrv, gamesProvider,$timeout) {
		$rootScope.favouritesSaveFilter = null;
		$rootScope.myBetsSaveFilter = null;

		
		//inicializamos a false la variable que determina si hay que volver al ticket tras la recarga de lotobolsa
		if ($rootScope.ticket === true){
			$rootScope.ticket = false;
		}

		// Funcionalidad de la landing
		$rootScope.$watch('lockProperties', function(deboIterar, oldValue) {
			if(!deboIterar){
				// traemos las imagenes del carrusel
				$scope.imageData = getImages();
				// Para hacer filtrado de si esta activo o no
				homeGames();
				// Comprobamos conexion y nos traemos los botes
				getConectionAndRafless();
				// Fin popUp de emergencias
				// Se comprueba si es la primera vez que accedes a la app para no estar siempre comprobando el aviso legal
				if (!$rootScope.notFirstTime) {
					var promiseGetLegalAd = storageProvider.getData(storageProvider.KEY_STORAGE_LEGALAD);
					promiseGetLegalAd.then(
						function(legalAdAccepted){
							if ( legalAdAccepted === null || legalAdAccepted == 'null' || legalAdAccepted === undefined ) {
								$rootScope.notFirstTime = true;
								try {
									htmlModalSrv.show($scope, "legalAdvice", "avisoLegal");
								} catch(e) {
									console.log("no carga aviso legal");
								}
							} else {
								// Funcionalidad de popUp de inicio de emergencias
								$scope.showPopup = function() {
									$rootScope.notFirstTime = true;
									if ($rootScope && $rootScope.selae && $rootScope.selae.properties && $rootScope.selae.properties.initPopUp) {
										popupSrv.showErrorPopup($rootScope.selae.properties.initPopUp);
									}
								};
								if (!$rootScope.notFirstTime) {
									$scope.showPopup();
								}
							}
						},
						function(error){
							Console.logPurple('Fracado al recuperar legalAdAccepted - landingCtrl.js ', error);
						}
					);
				}
			}
		});
		// Fin funcionalidad landing

	if (ionic.Platform.isAndroid()) {
		$scope.registerButton = true;
	} else {
		$scope.registerButton = false;
	}
	$scope.registerButton = true;

	$scope.data = null;
	$scope.botes = {};

	$scope.getRaffles = function(){
		console.log("BEFORE GET RAFLES HOME")
		requestSrv.request(config.services.cmsHost + config.services.proximosv3, "get", [{name:"game_id",value:"TODOS"}])
			.then(function(e) {
				console.log("INSIDE THEN PROXIMOS V3 home", e.data)
				$timeout(function() {
					if (e.data) {
						$scope.data = e.data;
						$scope.botes = $scope.gamesData.map(function(i, index){
							return $scope.data.map(function(j){
								if (i.text === j.game_id) {
									if (j.game_id ==="LNAC") {
										j.premio_bote = j.primer_premio;
									}
										if ( j.premio_bote > 1000000 ) {
											j.premio_bote = String(Math.round(j.premio_bote/1000000 * 100) / 100).replace('.',',');
											j.type = 'million';
										}
									return  { 	'reward' : j.premio_bote,
												 'type' : j.type || 'euros',
												 'game' :j.game_id
											};
								}
							}).filter(Boolean)[0];
						});
						$scope.jackpotLoaded = true;
					} else {
						$scope.jackpotLoaded = true;
					}
					$scope.$apply()
				})
				
			},function(err) {
				console.log("INSIDE catch PROXIMOS V3 home", err.data)

				$scope.jackpotLoaded = true;
				popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
			});
		};


	if(window.ga) {analyticsSrv.trackView('Home');}

	function homeGames() {
		$scope.gamesData = gamesProvider.getGames();
		$scope.gamesData = $filter('filter')($scope.gamesData, {visible: true});
	}

	$scope.active = false;
	function getImages(){
		return [
			{
				src: $rootScope.selae.properties["home.imagen1.fuente"],
				link: $rootScope.selae.properties["home.imagen1.url"],
				dest: $rootScope.selae.properties["home.imagen1.destino"],
				game_id: $rootScope.selae.properties["home.imagen1.game_id"]
			},
			{
				src: $rootScope.selae.properties["home.imagen2.fuente"],
				link: $rootScope.selae.properties["home.imagen2.url"],
				dest: $rootScope.selae.properties["home.imagen2.destino"],
				game_id: $rootScope.selae.properties["home.imagen2.game_id"]
			},
			{
				src: $rootScope.selae.properties["home.imagen3.fuente"],
				link: $rootScope.selae.properties["home.imagen3.url"],
				dest: $rootScope.selae.properties["home.imagen3.destino"],
				game_id: $rootScope.selae.properties["home.imagen3.game_id"]
			},
		];
	}

	// comprobación para poder desarrollar en ionicserve y lanzar apuestas
	function getConectionAndRafless () {
		if(window.cordova) {
			if(navigator.connection.type !== Connection.NONE) {
				$scope.getRaffles();
			} else {
				$scope.jackpotLoaded = true;
			}
		} else {
			$scope.getRaffles();
		}
	}


	$scope.selectGame = function(gameId, position) {

		$scope.itemSelected = gameId;

		var gameSelectedDiv = document.getElementById('home-gamegrid').getElementsByClassName('carousel-game');

		// Loop through the buttons and add the active class to the current/clicked button
		for (var i = 0; i < gameSelectedDiv.length; i++) {
			if (i !== position) {
				gameSelectedDiv[i].classList.add("disabled");
				gameSelectedDiv[i].classList.remove("activated");
			} else {
				gameSelectedDiv[i].classList.add("activated");
				gameSelectedDiv[i].classList.remove("disabled");
			}
		}
		$ionicScrollDelegate.scrollBottom([true]);
	};

	$scope.oneClickBet = function(){
		if ($scope.itemSelected) {
			if ($rootScope.logged){
				$state.go("app.quickBet", { game_id: $scope.itemSelected, voiceActive: false});
			}
			else{
				// popupSrv.showErrorPopup("mustBeLogged");
				loginSrv.showLogin($scope, 'Home', function() {
					$state.go("app.quickBet", { game_id: $scope.itemSelected, voiceActive: false});
				});
			}
		} else {
			popupSrv.showErrorPopup('noGameSelected');
		}
	};

	$scope.stepBet = function(){

		if ($scope.itemSelected) {
			console.log($scope.itemSelected); // sistem-error
			if ($rootScope.logged) {
				$state.go("app.stepBet", { game_id: $scope.itemSelected});
			}
			else{
				// popupSrv.showErrorPopup("mustBeLogged");
				loginSrv.showLogin($scope, 'Home', function() {
					$state.go("app.stepBet", { game_id: $scope.itemSelected});
				});
			}
		} else {
			popupSrv.showErrorPopup('noGameSelected');
		}
	};
	
	$scope.mas18 = function() {
		window.open($rootScope.selae.properties["mayor18.enlace"],'_system');
	};

	$scope.redHand = function() {
		window.open($rootScope.selae.properties["ordenacionjuego.enlace"],'_system');
	};

	$scope.rsc = function() {
		window.open($rootScope.selae.properties["responsabilidadsocial.enlace"],'_system');
	};

	$scope.juegoSeguro = function() {
		window.open($rootScope.selae.properties["juegoseguro.enlace"],'_system');
	};

	$scope.jugarBien = function() {
		window.open($rootScope.selae.properties["jugarBien.enlace"],'_system');
	};
	
	$scope.juegoResponsable = function() {
		window.open($rootScope.selae.properties["juegoResponsable.enlace"],'_system');
	};

	$scope.juegoAutorizado = function() {
		window.open($rootScope.selae.properties["juegoAutorizado.enlace"],'_system');
	};
	
	var recognizedText = '';
	$scope.record = function() {

		if ($rootScope.logged) {

			$scope.active = true;
		    var recognition = new SpeechRecognition();
		    recognition.lang = "es-ES";
		    
			recognition.onerror = function(event) {
				console.log(event);
		    	popupSrv.showErrorPopup("voiceError");
	            $scope.active = false;
	            $scope.$apply();
	        };

			recognition.onresult = function(event) {
		    	console.log("sucess", event);
		    	$scope.active = false;
		    	$scope.$apply();
		        if (event.results.length > 0) {
			    	console.log("sucess",event.results[0][0].transcript);
		            recognizedText = event.results[0][0].transcript;
		            if (ionic.Platform.isAndroid()) {
		            	if (recognizedText.toLowerCase().indexOf("jugar primitiva") !== -1){$state.go("app.quickBet", { game_id: 1, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("jugar bonoloto") !== -1){$state.go("app.quickBet", { game_id: 4, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("jugar euromillones") !== -1){$state.go("app.quickBet", { game_id: 3, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("jugar lotería") !== -1){$state.go("app.quickBet", { game_id: 9, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("jugar quiniela") !== -1){$state.go("app.quickBet", { game_id: 2, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("jugar quinigol") !== -1){$state.go("app.quickBet", { game_id: 6, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("jugar lototurf") !== -1){$state.go("app.quickBet", { game_id: 7, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("jugar gordo") !== -1){$state.go("app.quickBet", { game_id: 5, voiceActive:true});}
		            	else{
		            		popupSrv.showErrorPopup("didNotUnderstand");
		            	}
		            } else{
		            	if (recognizedText.toLowerCase().indexOf("primi") !== -1){$state.go("app.quickBet", { game_id: 1, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("bono") !== -1){$state.go("app.quickBet", { game_id: 4, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("euro") !== -1 || recognizedText.toLowerCase().indexOf("millon") !== -1){$state.go("app.quickBet", { game_id: 3, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("lotería") !== -1 || recognizedText.toLowerCase().indexOf("loteria") !== -1){$state.go("app.quickBet", { game_id: 9, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("quiniela") !== -1){$state.go("app.quickBet", { game_id: 2, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("gol") !== -1){$state.go("app.quickBet", { game_id: 6, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("loto") !== -1){$state.go("app.quickBet", { game_id: 7, voiceActive:true});}
		            	else if (recognizedText.toLowerCase().indexOf("gordo") !== -1){$state.go("app.quickBet", { game_id: 5, voiceActive:true});}
		            	else{
		            		popupSrv.showErrorPopup("didNotUnderstand");
		            	}
		            }
		        }
		    };

		    recognition.start();
		
        } else { popupSrv.showErrorPopup("mustBeLogged"); }
	};

	$scope.goResults = function(){
		if(window.ga !== undefined) {analyticsSrv.trackEvent('Home', 'Últimos Resultados', 'Últimos Resultados');}
		$state.go("app.results");
	};

	$scope.goMyBets = function(){
		if(window.ga !== undefined) {analyticsSrv.trackEvent('Home', 'Mis Apuestas', 'Mis Apuestas');}
		$state.go("app.myBets");
	};

	$scope.register = function(){
		if(window.ga !== undefined) {analyticsSrv.trackEvent('Home', 'Registro', "Registro");}
		if ( $rootScope.selae.properties.regWeb === "true" ) { 
			window.open(config.urls.register,'_system');
		 } else { 
			$state.go("app.registerRoute");
		  }
	};

	$scope.showVoiceHelp = function() {
        var content = "texto.comojugar.jugarporvoz";
        console.log(content);
        htmlModalSrv.show($scope, "modal", content);
	};
}]);
